python-dune-common_pre-release:
  tags: [saas-linux-large-amd64]
  stage: build
  variables:
    MODULE: "dune-common"
    MAKE_DEPENDENCIES: "python-scikit-build"
    DEPENDENCIES: "python-jinja python-mpi4py python-numpy python-portalocker python-setuptools python-wheel"
    TEST_DEPENDENCIES: "cmake"
  before_script:
    - echo -e '\n[dune-makepkg]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/testing/aur/dune-makepkg/$arch\n' | sudo tee -a /etc/pacman.conf
    - sudo pacman --needed --noconfirm --noprogressbar -Syuq >/dev/null 2>&1
    - sudo pacman --needed --noconfirm -S ${MAKE_DEPENDENCIES} >/dev/null 2>&1
  script:
    - sudo pacman --needed --noconfirm -S ${DEPENDENCIES} >/dev/null 2>&1
    - python -m venv --system-site-packages ~/dune-env && ~/dune-env/bin/pip -v --log ~/python-${MODULE}_pre-release_"$(date -u +"%Y-%m-%d-%H-%M-%S" --date='5 hours ago')".log install ${MODULE} --pre >/dev/null 2>&1
    - sudo pacman --noconfirm -Rscn ${MAKE_DEPENDENCIES} >/dev/null 2>&1
    - ~/dune-env/bin/pip list && ~/dune-env/bin/pip show ${MODULE//-/.} && ~/dune-env/bin/python -c 'from importlib import import_module; from os import environ; import_module(environ["MODULE"].replace("-", "."));'
  after_script:
    - mkdir -p ${CI_PROJECT_DIR}/log
    - mv ~/python-${MODULE}*.log ${CI_PROJECT_DIR}/log
    - export PATH="${PATH}:${HOME}/dune-env/bin"
    - sudo pacman --noconfirm -S ${TEST_DEPENDENCIES} >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${MODULE} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/log

python-dune-geometry_pre-release:
  tags: [saas-linux-large-amd64]
  stage: build
  variables:
    MODULE: "dune-geometry"
    MAKE_DEPENDENCIES: "python-scikit-build"
    DEPENDENCIES: "python-jinja python-mpi4py python-numpy python-portalocker python-setuptools python-wheel"
    TEST_DEPENDENCIES: "cmake"
  before_script:
    - echo -e '\n[dune-makepkg]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/testing/aur/dune-makepkg/$arch\n' | sudo tee -a /etc/pacman.conf
    - sudo pacman --needed --noconfirm --noprogressbar -Syuq >/dev/null 2>&1
    - sudo pacman --needed --noconfirm -S ${MAKE_DEPENDENCIES} >/dev/null 2>&1
  script:
    - sudo pacman --needed --noconfirm -S ${DEPENDENCIES} >/dev/null 2>&1
    - python -m venv --system-site-packages ~/dune-env && ~/dune-env/bin/pip -v --log ~/python-${MODULE}_pre-release_"$(date -u +"%Y-%m-%d-%H-%M-%S" --date='5 hours ago')".log install ${MODULE} --pre >/dev/null 2>&1
    - sudo pacman --noconfirm -Rscn ${MAKE_DEPENDENCIES} >/dev/null 2>&1
    - ~/dune-env/bin/pip list && ~/dune-env/bin/pip show ${MODULE//-/.} && ~/dune-env/bin/python -c 'from importlib import import_module; from os import environ; import_module(environ["MODULE"].replace("-", "."));'
  after_script:
    - mkdir -p ${CI_PROJECT_DIR}/log
    - mv ~/python-${MODULE}*.log ${CI_PROJECT_DIR}/log
    - export PATH="${PATH}:${HOME}/dune-env/bin"
    - sudo pacman --noconfirm -S ${TEST_DEPENDENCIES} >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${MODULE} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/log

python-dune-grid_pre-release:
  tags: [saas-linux-large-amd64]
  stage: build
  variables:
    MODULE: "dune-grid"
    MAKE_DEPENDENCIES: "python-scikit-build"
    DEPENDENCIES: "alberta python-jinja python-mpi4py python-numpy python-portalocker python-setuptools python-wheel"
    TEST_DEPENDENCIES: "cmake"
  before_script:
    - echo -e '\n[dune-makepkg]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/testing/aur/dune-makepkg/$arch\n' | sudo tee -a /etc/pacman.conf
    - sudo pacman --needed --noconfirm --noprogressbar -Syuq >/dev/null 2>&1
    - sudo pacman --needed --noconfirm -S ${MAKE_DEPENDENCIES} >/dev/null 2>&1
  script:
    - sudo pacman --needed --noconfirm -S ${DEPENDENCIES} >/dev/null 2>&1
    - python -m venv --system-site-packages ~/dune-env && ~/dune-env/bin/pip -v --log ~/python-${MODULE}_pre-release_"$(date -u +"%Y-%m-%d-%H-%M-%S" --date='5 hours ago')".log install ${MODULE} --pre >/dev/null 2>&1
    - sudo pacman --noconfirm -Rscn ${MAKE_DEPENDENCIES} >/dev/null 2>&1
    - ~/dune-env/bin/pip list && ~/dune-env/bin/pip show ${MODULE//-/.} && ~/dune-env/bin/python -c 'from importlib import import_module; from os import environ; import_module(environ["MODULE"].replace("-", "."));'
    - ~/dune-env/bin/python -c 'from dune.utility import components; components("grid");'
  after_script:
    - mkdir -p ${CI_PROJECT_DIR}/log
    - mv ~/python-${MODULE}*.log ${CI_PROJECT_DIR}/log
    - export PATH="${PATH}:${HOME}/dune-env/bin"
    - sudo pacman --noconfirm -S ${TEST_DEPENDENCIES} >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${MODULE} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/log

python-dune-istl_pre-release:
  tags: [saas-linux-large-amd64]
  stage: build
  variables:
    MODULE: "dune-istl"
    MAKE_DEPENDENCIES: "python-scikit-build"
    DEPENDENCIES: "python-jinja python-mpi4py python-numpy python-portalocker python-setuptools python-wheel"
    TEST_DEPENDENCIES: "cmake"
  before_script:
    - echo -e '\n[dune-makepkg]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/testing/aur/dune-makepkg/$arch\n' | sudo tee -a /etc/pacman.conf
    - sudo pacman --needed --noconfirm --noprogressbar -Syuq >/dev/null 2>&1
    - sudo pacman --needed --noconfirm -S ${MAKE_DEPENDENCIES} >/dev/null 2>&1
  script:
    - sudo pacman --needed --noconfirm -S ${DEPENDENCIES} >/dev/null 2>&1 # arpack arpackpp superlu suitesparse
    - python -m venv --system-site-packages ~/dune-env && ~/dune-env/bin/pip -v --log ~/python-${MODULE}_pre-release_"$(date -u +"%Y-%m-%d-%H-%M-%S" --date='5 hours ago')".log install ${MODULE} --pre >/dev/null 2>&1
    - sudo pacman --noconfirm -Rscn ${MAKE_DEPENDENCIES} >/dev/null 2>&1
    - ~/dune-env/bin/pip list && ~/dune-env/bin/pip show ${MODULE//-/.} && ~/dune-env/bin/python -c 'from importlib import import_module; from os import environ; import_module(environ["MODULE"].replace("-", "."));'
  after_script:
    - mkdir -p ${CI_PROJECT_DIR}/log
    - mv ~/python-${MODULE}*.log ${CI_PROJECT_DIR}/log
    - export PATH="${PATH}:${HOME}/dune-env/bin"
    - sudo pacman --noconfirm -S ${TEST_DEPENDENCIES} >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${MODULE} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/log

python-dune-localfunctions_pre-release:
  tags: [saas-linux-large-amd64]
  stage: build
  variables:
    MODULE: "dune-localfunctions"
    MAKE_DEPENDENCIES: "python-scikit-build"
    DEPENDENCIES: "python-jinja python-mpi4py python-numpy python-portalocker python-setuptools python-wheel"
    TEST_DEPENDENCIES: "cmake"
  before_script:
    - echo -e '\n[dune-makepkg]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/testing/aur/dune-makepkg/$arch\n' | sudo tee -a /etc/pacman.conf
    - sudo pacman --needed --noconfirm --noprogressbar -Syuq >/dev/null 2>&1
    - sudo pacman --needed --noconfirm -S ${MAKE_DEPENDENCIES} >/dev/null 2>&1
  script:
    - sudo pacman --needed --noconfirm -S ${DEPENDENCIES} >/dev/null 2>&1
    - python -m venv --system-site-packages ~/dune-env && ~/dune-env/bin/pip -v --log ~/python-${MODULE}_pre-release_"$(date -u +"%Y-%m-%d-%H-%M-%S" --date='5 hours ago')".log install ${MODULE} --pre >/dev/null 2>&1
    - sudo pacman --noconfirm -Rscn ${MAKE_DEPENDENCIES} >/dev/null 2>&1
    - ~/dune-env/bin/pip list && ~/dune-env/bin/pip show ${MODULE//-/.} && ~/dune-env/bin/python -c 'from importlib import import_module; from os import environ; import_module(environ["MODULE"].replace("-", "."));'
  after_script:
    - mkdir -p ${CI_PROJECT_DIR}/log
    - mv ~/python-${MODULE}*.log ${CI_PROJECT_DIR}/log
    - export PATH="${PATH}:${HOME}/dune-env/bin"
    - sudo pacman --noconfirm -S ${TEST_DEPENDENCIES} >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${MODULE} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/log
